// i wanna thank TehRealSalt for their CustomHUD library! i don't wanna replace the graphics for the hud, so this hud wouldn't be possible without it! -TPRS

if not (rawget(_G, "customhud"))
	print("https://mb.srb2.org/addons/custom-hud-library.5278/\ndon't mind me, just putting it here")
end

customhud.SetupFont('OTFNT', 0, 16)
customhud.SetupNumberFont('OTL0', 0, 16)

customhud.SetupItem('stagetitle', 'oldtitlecard')

local function ST_drawLevelTitle(v, timeinmap)
	local lvlttl = mapheaderinfo[gamemap].lvlttl
	local subttl = mapheaderinfo[gamemap].subttl
	local actnum = mapheaderinfo[gamemap].actnum
	local lvlttlxpos
	local subttlxpos = 160
	local ttlnumxpos
	local zonexpos
	
	local lvlttly = 0
	local zoney = 200
	
	if (not (timeinmap > 2 and timeinmap-3 < 110))
		return
	end
	
	if (actnum > 0)
		lvlttlxpos = ((320/2) - (customhud.CustomFontStringWidth(v, lvlttl, 'OTFNT')/2)) - customhud.CustomNumWidth(v, actnum, 'OTL0');
	else
		lvlttlxpos = ((320/2) - (customhud.CustomFontStringWidth(v, lvlttl, 'OTFNT')/2));
	end
	
	ttlnumxpos = lvlttlxpos + customhud.CustomFontStringWidth(v, lvlttl, 'OTFNT');
	zonexpos = ttlnumxpos - customhud.CustomFontStringWidth(v, 'ZONE', 'OTFNT');
	
	if (lvlttlxpos < 0)
		lvlttlxpos = 0
	end
	
	if (timeinmap-3 == 0) zoney = 200 lvlttly = 0
	elseif (timeinmap-3 == 1) zoney = 188 lvlttly = 12
	elseif (timeinmap-3 == 2) zoney = 176 lvlttly = 24
	elseif (timeinmap-3 == 3) zoney = 164 lvlttly = 36
	elseif (timeinmap-3 == 4) zoney = 152 lvlttly = 48
	elseif (timeinmap-3 == 5) zoney = 140 lvlttly = 60
	elseif (timeinmap-3 == 6) zoney = 128 lvlttly = 72
	elseif (timeinmap-3 == 105) zoney = 80 lvlttly = 104
	elseif (timeinmap-3 == 106) zoney = 56 lvlttly = 180
	elseif (timeinmap-3 == 107) zoney = 32 lvlttly = 152
	elseif (timeinmap-3 == 108) zoney = 8 lvlttly = 176
	elseif (timeinmap-3 == 109) zoney = 0 lvlttly = 200
	else zoney = 104 lvlttly = 80
	end
	
	if (actnum > 0)
		customhud.CustomNum(v, ttlnumxpos, zoney, actnum, 'OTL0')
	end
	
	customhud.CustomFontString(v, lvlttlxpos, lvlttly, lvlttl, 'OTFNT')
	
	if (not (mapheaderinfo[gamemap].levelflags & LF_NOZONE))
		customhud.CustomFontString(v, zonexpos, zoney, 'ZONE', 'OTFNT')
	end
	
	if (lvlttly+48 < 200)
		v.drawString(subttlxpos, lvlttly+48, subttl, V_ALLOWLOWERCASE, "center")
	end
end

addHook("PlayerSpawn", function(p)
	p.oldTitleCardTimer = 0
end)

addHook("PlayerThink", function(p)
	p.oldTitleCardTimer = $ + 1
end)

addHook("MapLoad", function()
	for p in players.iterate() do
		p.oldTitleCardTimer = 0
	end
end)

hud.add(function(v, p)
	if (customhud.CheckType('stagetitle') != 'oldtitlecard') return end

	ST_drawLevelTitle(v, p.oldTitleCardTimer)
end, "titlecard")